summaryrefslogtreecommitdiffstats
path: root/iptables/tests/shell/testcases/ebtables
diff options
context:
space:
mode:
authorPhil Sutter <phil@nwl.cc>2018-08-16 18:14:36 +0200
committerPablo Neira Ayuso <pablo@netfilter.org>2018-08-16 19:43:47 +0200
commit294f9ef5ee354ff902dfdc091a604f93083c248d (patch)
tree8bf3106f6f2e57625141c25bdc9ea16e27ecfee9 /iptables/tests/shell/testcases/ebtables
parent6f29aa8e3486e2c12ab48425a7e9b01dd6417665 (diff)
ebtables: Fix entries count in chain listing
The previous fix for reference counts in iptables-nft output wasn't complete: While iptables lists the number of references for each custom chain (i.e., the number of jumps to it), ebtables lists number of entries (i.e., the number of rules contained) for each chain. Both used the same value for it, although they are different metrics. Fix this by passing both numbers separately to the 'print_header' callback so that each tool may print the desired value. Fixes: a0698de9866d2 ("xtables: Do not count rules as chain references") Signed-off-by: Phil Sutter <phil@nwl.cc> Signed-off-by: Pablo Neira Ayuso <pablo@netfilter.org>
Diffstat (limited to 'iptables/tests/shell/testcases/ebtables')
-rwxr-xr-xiptables/tests/shell/testcases/ebtables/0001-ebtables-basic_030
1 files changed, 30 insertions, 0 deletions
diff --git a/iptables/tests/shell/testcases/ebtables/0001-ebtables-basic_0 b/iptables/tests/shell/testcases/ebtables/0001-ebtables-basic_0
index 05a2715f..b0db216a 100755
--- a/iptables/tests/shell/testcases/ebtables/0001-ebtables-basic_0
+++ b/iptables/tests/shell/testcases/ebtables/0001-ebtables-basic_0
@@ -28,6 +28,36 @@ case "$XT_MULTI" in
exit 1
fi
+ $XT_MULTI ebtables -L FOO | grep -q 'entries: 0'
+ if [ $? -ne 0 ]; then
+ echo "Unexpected entries count in empty unreferenced chain"
+ $XT_MULTI ebtables -L
+ exit 1
+ fi
+
+ $XT_MULTI ebtables -A FORWARD -j FOO
+ $XT_MULTI ebtables -L FORWARD | grep -q 'entries: 1'
+ if [ $? -ne 0 ]; then
+ echo "Unexpected entries count in FORWARD chain"
+ $XT_MULTI ebtables -L
+ exit 1
+ fi
+
+ $XT_MULTI ebtables -L FOO | grep -q 'entries: 0'
+ if [ $? -ne 0 ]; then
+ echo "Unexpected entries count in empty referenced chain"
+ $XT_MULTI ebtables -L
+ exit 1
+ fi
+
+ $XT_MULTI ebtables -A FOO -j ACCEPT
+ $XT_MULTI ebtables -L FOO | grep -q 'entries: 1'
+ if [ $? -ne 0 ]; then
+ echo "Unexpected entries count in non-empty referenced chain"
+ $XT_MULTI ebtables -L
+ exit 1
+ fi
+
$XT_MULTI ebtables -t filter -N BAR || exit 1
$XT_MULTI ebtables -t filter -N BAZ || exit 1